From 4b005ee60e4d8d01543db4a8c54687af4bb1ff6b Mon Sep 17 00:00:00 2001
From: guowenxue <guowenxue@gmail.com>
Date: Fri, 21 Aug 2020 14:26:01 +0800
Subject: [PATCH] Add libressl build shell script

---
 3rdparty/libressl/build.sh |   95 +++++++++++++++++++++++++++++++++++++++++++++++
 1 files changed, 95 insertions(+), 0 deletions(-)

diff --git a/3rdparty/libressl/build.sh b/3rdparty/libressl/build.sh
new file mode 100755
index 0000000..9952271
--- /dev/null
+++ b/3rdparty/libressl/build.sh
@@ -0,0 +1,95 @@
+#!/bin/bash
+
+#+--------------------------------------------------------------------------------------------
+#|Description:  This shell script used download and compile libressl for ARM
+#|     Author:  GuoWenxue <guowenxue@gmail.com>
+#|  ChangeLog:
+#|           1, Initialize 1.0.0 on 2011.04.12
+#+--------------------------------------------------------------------------------------------
+
+PREFIX_PATH=`pwd`/../install
+
+LYFTP_SRC=ftp://master.iot-yun.club/src/
+
+CROSSTOOL=/opt/xtools/arm920t/bin/arm-linux-
+
+function msg_banner()
+{
+    echo ""
+    echo "+-----------------------------------------------------------------------"
+    echo "|  $1 "
+    echo "+-----------------------------------------------------------------------"
+    echo ""
+}
+
+function check_result()
+{
+    if [ $? != 0 ] ; then
+       echo ""
+       echo "+-----------------------------------------------------------------------"
+       echo "|  $1 "
+       echo "+-----------------------------------------------------------------------"
+       echo ""
+       exit ;
+    fi
+}
+
+function export_cross()
+{
+    # export cross toolchain
+    export CC=${CROSSTOOL}gcc
+    export AS=${CROSSTOOL}as
+    export AR=${CROSSTOOL}ar
+    export LD=${CROSSTOOL}ld
+    export NM=${CROSSTOOL}nm
+    export RANLIB=${CROSSTOOL}ranlib
+    export OBJDUMP=${CROSSTOOL}objdump
+    export STRIP=${CROSSTOOL}strip
+
+    # export cross configure 
+    export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
+
+    # Clear LDFLAGS and CFLAGS
+    export LDFLAGS=
+    export CFLAGS=
+}
+
+function compile_libressl()
+{
+    SRC_NAME=libressl-2.9.2
+    PACK_SUFIX=tar.gz 
+
+    if [ -f ${PREFIX_PATH}/lib/libcrypto.a ] ; then 
+        msg_banner "$SRC_NAME already compile and installed"
+        return 0;
+    fi  
+    
+    msg_banner "Start cross compile $SRC_NAME " 
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then 
+        #wget https://ftp.openbsd.org/pub/OpenBSD/LibreSSL/${SRC_NAME}.${PACK_SUFIX} 
+        wget ${LYFTP_SRC}/${SRC_NAME}.${PACK_SUFIX}
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi  
+
+    tar -xzf ${SRC_NAME}.${PACK_SUFIX}
+    cd ${SRC_NAME} 
+    touch *
+    
+    export CFLAGS=-fPIC
+    #./configure ${CONFIG_CROSS} --prefix=${PREFIX_PATH} --with-pic --disable-shared --enable-static LIBS="-lpthread"
+    ./configure ${CONFIG_CROSS} --prefix=${PREFIX_PATH} --with-pic LIBS="-lpthread"
+
+    make && make install 
+    check_result "ERROR: compile ${SRC_NAME} failure" 
+
+    cd - 
+} 
+
+printf "\nWARRNING: libressl is a candidate of openssl, so don't compile it if openssl enabled\n\n"
+exit;
+
+export_cross
+
+compile_libressl
+
+

--
Gitblit v1.9.1